diff --git a/drivers/target/iscsi/iscsi_target.c b/drivers/target/iscsi/iscsi_target.c
index 1d25e64b068a..b1d61f717b3d 100644
--- a/drivers/target/iscsi/iscsi_target.c
+++ b/drivers/target/iscsi/iscsi_target.c
@@ -4591,7 +4591,7 @@ static void iscsit_logout_post_handler_closesession(
 	/*
 	 * Traditional iscsi/tcp will invoke this logic from TX thread
 	 * context during session logout, so clear tx_thread_active and
-	 * sleep if iscsit_close_connection() has not already occured.
+	 * sleep if iscsit_close_connection() has not already occurred.
 	 *
 	 * Since iser-target invokes this logic from it's own workqueue,
 	 * always sleep waiting for RX/TX thread shutdown to complete
diff --git a/drivers/target/iscsi/iscsi_target_login.c b/drivers/target/iscsi/iscsi_target_login.c
index 90b870f234f0..761d2783c89c 100644
--- a/drivers/target/iscsi/iscsi_target_login.c
+++ b/drivers/target/iscsi/iscsi_target_login.c
@@ -570,7 +570,7 @@ int iscsi_login_post_auth_non_zero_tsih(
 	/*
 	 * By following item 5 in the login table,  if we have found
 	 * an existing ISID and a valid/existing TSIH and an existing
-	 * CID we do connection reinstatement.  Currently we dont not
+	 * CID we do connection reinstatement.  Currently we don't not
 	 * support it so we send back an non-zero status class to the
 	 * initiator and release the new connection.
 	 */
diff --git a/drivers/target/iscsi/iscsi_target_nego.c b/drivers/target/iscsi/iscsi_target_nego.c
index fa3fb5f4e6bc..ca24804e5386 100644
--- a/drivers/target/iscsi/iscsi_target_nego.c
+++ b/drivers/target/iscsi/iscsi_target_nego.c
@@ -557,7 +557,7 @@ static void iscsi_target_do_login_rx(struct work_struct *work)
 	 * before initial PDU processing in iscsi_target_start_negotiation()
 	 * has completed, go ahead and retry until it's cleared.
 	 *
-	 * Otherwise if the TCP connection drops while this is occuring,
+	 * Otherwise if the TCP connection drops while this is occurring,
 	 * iscsi_target_start_negotiation() will detect the failure, call
 	 * cancel_delayed_work_sync(&conn->login_work), and cleanup the
 	 * remaining iscsi connection resources from iscsi_np process context.
@@ -1050,7 +1050,7 @@ static int iscsi_target_do_login(struct iscsit_conn *conn, struct iscsi_login *l
 				/*
 				 * Check to make sure the TCP connection has not
 				 * dropped asynchronously while session reinstatement
-				 * was occuring in this kthread context, before
+				 * was occurring in this kthread context, before
 				 * transitioning to full feature phase operation.
 				 */
 				if (iscsi_target_sk_check_close(conn))
diff --git a/drivers/target/iscsi/iscsi_target_parameters.h b/drivers/target/iscsi/iscsi_target_parameters.h
index 00fbbebb8c75..c143d487afa8 100644
--- a/drivers/target/iscsi/iscsi_target_parameters.h
+++ b/drivers/target/iscsi/iscsi_target_parameters.h
@@ -95,7 +95,7 @@ extern void iscsi_set_session_parameters(struct iscsi_sess_ops *,
 #define OFMARKINT			"OFMarkInt"
 
 /*
- * Parameter names of iSCSI Extentions for RDMA (iSER).  See RFC-5046
+ * Parameter names of iSCSI Extensions for RDMA (iSER).  See RFC-5046
  */
 #define RDMAEXTENSIONS			"RDMAExtensions"
 #define INITIATORRECVDATASEGMENTLENGTH	"InitiatorRecvDataSegmentLength"
diff --git a/drivers/target/iscsi/iscsi_target_tpg.c b/drivers/target/iscsi/iscsi_target_tpg.c
index f7bac98fd4fe..23478c8957df 100644
--- a/drivers/target/iscsi/iscsi_target_tpg.c
+++ b/drivers/target/iscsi/iscsi_target_tpg.c
@@ -313,7 +313,7 @@ int iscsit_tpg_enable_portal_group(struct iscsi_portal_group *tpg)
 	}
 	/*
 	 * Make sure that AuthMethod does not contain None as an option
-	 * unless explictly disabled.  Set the default to CHAP if authentication
+	 * unless explicitly disabled.  Set the default to CHAP if authentication
 	 * is enforced (as per default), and remove the NONE option.
 	 */
 	param = iscsi_find_param_from_key(AUTHMETHOD, tpg->param_list);
diff --git a/drivers/target/target_core_sbc.c b/drivers/target/target_core_sbc.c
index 6a02561cc20c..35dfe5cb40ec 100644
--- a/drivers/target/target_core_sbc.c
+++ b/drivers/target/target_core_sbc.c
@@ -573,7 +573,7 @@ sbc_compare_and_write(struct se_cmd *cmd)
 	int rc;
 	/*
 	 * Submit the READ first for COMPARE_AND_WRITE to perform the
-	 * comparision using SGLs at cmd->t_bidi_data_sg..
+	 * comparison using SGLs at cmd->t_bidi_data_sg..
 	 */
 	rc = down_interruptible(&dev->caw_sem);
 	if (rc != 0) {
diff --git a/drivers/target/target_core_transport.c b/drivers/target/target_core_transport.c
index c81def3c96df..665eb2d9bc19 100644
--- a/drivers/target/target_core_transport.c
+++ b/drivers/target/target_core_transport.c
@@ -1820,7 +1820,7 @@ EXPORT_SYMBOL_GPL(target_submit_prep);
  * This may only be called from process context, and also currently
  * assumes internal allocation of fabric payload buffer by target-core.
  *
- * It also assumes interal target core SGL memory allocation.
+ * It also assumes internal target core SGL memory allocation.
  *
  * This function must only be used by drivers that do their own
  * sync during shutdown and does not use target_stop_session. If there
@@ -3447,7 +3447,7 @@ static const struct sense_detail sense_detail_table[] = {
 		 * REGISTER AND MOVE service actionis attempted,
 		 * but there are insufficient device server resources to complete the
 		 * operation, then the command shall be terminated with CHECK CONDITION
-		 * status, with the sense key set to ILLEGAL REQUEST,and the additonal
+		 * status, with the sense key set to ILLEGAL REQUEST,and the additional
 		 * sense code set to INSUFFICIENT REGISTRATION RESOURCES.
 		 */
 		.key = ILLEGAL_REQUEST,
diff --git a/drivers/target/target_core_user.c b/drivers/target/target_core_user.c
index 7eb94894bd68..d13e38fcee4c 100644
--- a/drivers/target/target_core_user.c
+++ b/drivers/target/target_core_user.c
@@ -1985,7 +1985,7 @@ static int tcmu_release(struct uio_info *info, struct inode *inode)
 		tcmu_free_cmd(cmd);
 	}
 	/*
-	 * We only freed data space, not ring space. Therefore we dont call
+	 * We only freed data space, not ring space. Therefore we don't call
 	 * run_tmr_queue, but call run_qfull_queue if tmr_list is empty.
 	 */
 	if (freed && list_empty(&udev->tmr_queue))
@@ -3125,7 +3125,7 @@ static ssize_t tcmu_free_kept_buf_store(struct config_item *item, const char *pa
 	tcmu_cmd_free_data(cmd, cmd->dbi_cnt);
 	tcmu_free_cmd(cmd);
 	/*
-	 * We only freed data space, not ring space. Therefore we dont call
+	 * We only freed data space, not ring space. Therefore we don't call
 	 * run_tmr_queue, but call run_qfull_queue if tmr_list is empty.
 	 */
 	if (list_empty(&udev->tmr_queue))
diff --git a/drivers/target/target_core_xcopy.h b/drivers/target/target_core_xcopy.h
index 0aad7dc65895..5337d4f89a8d 100644
--- a/drivers/target/target_core_xcopy.h
+++ b/drivers/target/target_core_xcopy.h
@@ -42,7 +42,7 @@ struct xcopy_op {
 };
 
 /*
- * Receive Copy Results Sevice Actions
+ * Receive Copy Results Service Actions
  */
 #define RCR_SA_COPY_STATUS		0x00
 #define RCR_SA_RECEIVE_DATA		0x01
diff --git a/drivers/target/tcm_fc/tfc_conf.c b/drivers/target/tcm_fc/tfc_conf.c
index 5ee03d1cba2b..4b066e14f885 100644
--- a/drivers/target/tcm_fc/tfc_conf.c
+++ b/drivers/target/tcm_fc/tfc_conf.c
@@ -281,7 +281,7 @@ static void ft_del_tpg(struct se_portal_group *se_tpg)
 
 	destroy_workqueue(tpg->workqueue);
 
-	/* Wait for sessions to be freed thru RCU, for BUG_ON below */
+	/* Wait for sessions to be freed through RCU, for BUG_ON below */
 	synchronize_rcu();
 
 	mutex_lock(&ft_lport_lock);
diff --git a/drivers/target/tcm_fc/tfc_sess.c b/drivers/target/tcm_fc/tfc_sess.c
index 593540da9346..e2ff506ca68d 100644
--- a/drivers/target/tcm_fc/tfc_sess.c
+++ b/drivers/target/tcm_fc/tfc_sess.c
@@ -98,7 +98,7 @@ static void ft_tport_delete(struct ft_tport *tport)
 
 /*
  * Add local port.
- * Called thru fc_lport_iterate().
+ * Called through fc_lport_iterate().
  */
 void ft_lport_add(struct fc_lport *lport, void *arg)
 {
@@ -110,7 +110,7 @@ void ft_lport_add(struct fc_lport *lport, void *arg)
 
 /*
  * Delete local port.
- * Called thru fc_lport_iterate().
+ * Called through fc_lport_iterate().
  */
 void ft_lport_del(struct fc_lport *lport, void *arg)
 {