diff --git a/drivers/target/iscsi/iscsi_target.c b/drivers/target/iscsi/iscsi_target.c
index 1d25e64b068a..da05a65bb247 100644
--- a/drivers/target/iscsi/iscsi_target.c
+++ b/drivers/target/iscsi/iscsi_target.c
@@ -108,7 +108,7 @@ void iscsit_put_tiqn_for_login(struct iscsi_tiqn *tiqn)
 
 /*
  * Note that IQN formatting is expected to be done in userspace, and
- * no explict IQN format checks are done here.
+ * no explicit IQN format checks are done here.
  */
 struct iscsi_tiqn *iscsit_add_tiqn(unsigned char *buf)
 {
@@ -1033,7 +1033,7 @@ int iscsit_setup_scsi_cmd(struct iscsit_conn *conn, struct iscsit_cmd *cmd,
 		 *  Expected Data Transfer Length and/or Bidirectional Read
 		 *  Expected Data Transfer Length are 0"
 		 *
-		 * For this case, go ahead and clear the unnecssary bits
+		 * For this case, go ahead and clear the unnecessary bits
 		 * to avoid any confusion with ->data_direction.
 		 */
 		hdr->flags &= ~ISCSI_FLAG_CMD_READ;
@@ -4591,7 +4591,7 @@ static void iscsit_logout_post_handler_closesession(
 	/*
 	 * Traditional iscsi/tcp will invoke this logic from TX thread
 	 * context during session logout, so clear tx_thread_active and
-	 * sleep if iscsit_close_connection() has not already occured.
+	 * sleep if iscsit_close_connection() has not already occurred.
 	 *
 	 * Since iser-target invokes this logic from it's own workqueue,
 	 * always sleep waiting for RX/TX thread shutdown to complete
diff --git a/drivers/target/iscsi/iscsi_target_erl0.c b/drivers/target/iscsi/iscsi_target_erl0.c
index 07e9cf431edd..604378b7bfe2 100644
--- a/drivers/target/iscsi/iscsi_target_erl0.c
+++ b/drivers/target/iscsi/iscsi_target_erl0.c
@@ -343,7 +343,7 @@ static int iscsit_dataout_check_datasn(
 
 	/*
 	 * Considering the target has no method of re-requesting DataOUT
-	 * by DataSN, if we receieve a greater DataSN than expected we
+	 * by DataSN, if we receive a greater DataSN than expected we
 	 * assume the functions for DataPDUInOrder=[Yes,No] below will
 	 * handle it.
 	 *
@@ -394,7 +394,7 @@ static int iscsit_dataout_pre_datapduinorder_yes(
 
 	/*
 	 * For DataSequenceInOrder=Yes: If the offset is greater than the global
-	 * DataPDUInOrder=Yes offset counter in struct iscsit_cmd a protcol error has
+	 * DataPDUInOrder=Yes offset counter in struct iscsit_cmd a protocol error has
 	 * occurred and fail the connection.
 	 *
 	 * For DataSequenceInOrder=No: If the offset is greater than the per
diff --git a/drivers/target/iscsi/iscsi_target_login.c b/drivers/target/iscsi/iscsi_target_login.c
index 90b870f234f0..bbfaa428f734 100644
--- a/drivers/target/iscsi/iscsi_target_login.c
+++ b/drivers/target/iscsi/iscsi_target_login.c
@@ -589,7 +589,7 @@ int iscsi_login_post_auth_non_zero_tsih(
 	 * We use the original ExpStatSN sent in the first login request
 	 * to acknowledge commands for the failed connection.
 	 *
-	 * Also note that an explict logout may have already been sent,
+	 * Also note that an explicit logout may have already been sent,
 	 * but the response may not be sent due to additional connection
 	 * loss.
 	 */
diff --git a/drivers/target/iscsi/iscsi_target_parameters.h b/drivers/target/iscsi/iscsi_target_parameters.h
index 00fbbebb8c75..c143d487afa8 100644
--- a/drivers/target/iscsi/iscsi_target_parameters.h
+++ b/drivers/target/iscsi/iscsi_target_parameters.h
@@ -95,7 +95,7 @@ extern void iscsi_set_session_parameters(struct iscsi_sess_ops *,
 #define OFMARKINT			"OFMarkInt"
 
 /*
- * Parameter names of iSCSI Extentions for RDMA (iSER).  See RFC-5046
+ * Parameter names of iSCSI Extensions for RDMA (iSER).  See RFC-5046
  */
 #define RDMAEXTENSIONS			"RDMAExtensions"
 #define INITIATORRECVDATASEGMENTLENGTH	"InitiatorRecvDataSegmentLength"
diff --git a/drivers/target/iscsi/iscsi_target_tmr.c b/drivers/target/iscsi/iscsi_target_tmr.c
index 9c4aa01b6351..037d8e82d9ed 100644
--- a/drivers/target/iscsi/iscsi_target_tmr.c
+++ b/drivers/target/iscsi/iscsi_target_tmr.c
@@ -449,7 +449,7 @@ static int iscsit_task_reassign_complete(
 /*
  *	Handles special after-the-fact actions related to TMRs.
  *	Right now the only one that its really needed for is
- *	connection recovery releated TASK_REASSIGN.
+ *	connection recovery related TASK_REASSIGN.
  */
 int iscsit_tmr_post_handler(struct iscsit_cmd *cmd, struct iscsit_conn *conn)
 {
diff --git a/drivers/target/iscsi/iscsi_target_tpg.c b/drivers/target/iscsi/iscsi_target_tpg.c
index f7bac98fd4fe..23478c8957df 100644
--- a/drivers/target/iscsi/iscsi_target_tpg.c
+++ b/drivers/target/iscsi/iscsi_target_tpg.c
@@ -313,7 +313,7 @@ int iscsit_tpg_enable_portal_group(struct iscsi_portal_group *tpg)
 	}
 	/*
 	 * Make sure that AuthMethod does not contain None as an option
-	 * unless explictly disabled.  Set the default to CHAP if authentication
+	 * unless explicitly disabled.  Set the default to CHAP if authentication
 	 * is enforced (as per default), and remove the NONE option.
 	 */
 	param = iscsi_find_param_from_key(AUTHMETHOD, tpg->param_list);
diff --git a/drivers/target/target_core_alua.h b/drivers/target/target_core_alua.h
index fc9637cce825..6f54bca0bc2f 100644
--- a/drivers/target/target_core_alua.h
+++ b/drivers/target/target_core_alua.h
@@ -47,7 +47,7 @@
 #define ALUA_STATUS_ALTERED_BY_IMPLICIT_ALUA		0x02
 
 /*
- * From spc4r17, Table D.1: ASC and ASCQ Assignement
+ * From spc4r17, Table D.1: ASC and ASCQ Assignment
  */
 #define ASCQ_04H_ALUA_STATE_TRANSITION			0x0a
 #define ASCQ_04H_ALUA_TG_PT_STANDBY			0x0b
diff --git a/drivers/target/target_core_configfs.c b/drivers/target/target_core_configfs.c
index c40217f44b1b..4fdd48a27441 100644
--- a/drivers/target/target_core_configfs.c
+++ b/drivers/target/target_core_configfs.c
@@ -204,7 +204,7 @@ static struct config_group *target_core_register_fabric(
 		 * mkdir -p /sys/kernel/config/target/$MODULE_NAME
 		 *
 		 * Note that this does not limit which TCM fabric module can be
-		 * registered, but simply provids auto loading logic for modules with
+		 * registered, but simply provides auto loading logic for modules with
 		 * mkdir(2) system calls with known TCM fabric modules.
 		 */
 
diff --git a/drivers/target/target_core_pr.c b/drivers/target/target_core_pr.c
index 80b7d85030d0..3c1b13a18916 100644
--- a/drivers/target/target_core_pr.c
+++ b/drivers/target/target_core_pr.c
@@ -512,7 +512,7 @@ static int core_scsi3_pr_seq_non_holder(struct se_cmd *cmd, u32 pr_reg_type,
 			 * PR TYPEs to pass for registered and
 			 * non-registered_nexuxes NOT holding the reservation.
 			 *
-			 * We only make noise for the unregisterd nexuses,
+			 * We only make noise for the unregistered nexuses,
 			 * as we expect registered non-reservation holding
 			 * nexuses to issue CDBs.
 			 */
@@ -1658,7 +1658,7 @@ core_scsi3_decode_spec_i_port(
 			goto out_unmap;
 		}
 		/*
-		 * Locate the desintation struct se_dev_entry pointer for matching
+		 * Locate the destination struct se_dev_entry pointer for matching
 		 * RELATIVE TARGET PORT IDENTIFIER on the receiving I_T Nexus
 		 * Target Port.
 		 */
@@ -1814,7 +1814,7 @@ core_scsi3_decode_spec_i_port(
 out:
 	/*
 	 * For the failure case, release everything from tid_dest_list
-	 * including *dest_pr_reg and the configfs dependances..
+	 * including *dest_pr_reg and the configfs dependences..
 	 */
 	list_for_each_entry_safe(tidh, tidh_tmp, &tid_dest_list, dest_list) {
 		bool is_local = false;
@@ -3643,7 +3643,7 @@ target_scsi3_emulate_pr_out(struct se_cmd *cmd)
 	}
 	/*
 	 * If the backend device has been configured to force APTPL metadata
-	 * write-out, go ahead and propigate aptpl=1 down now.
+	 * write-out, go ahead and propagate aptpl=1 down now.
 	 */
 	if (dev->dev_attrib.force_pr_aptpl)
 		aptpl = 1;
diff --git a/drivers/target/target_core_sbc.c b/drivers/target/target_core_sbc.c
index 6a02561cc20c..35dfe5cb40ec 100644
--- a/drivers/target/target_core_sbc.c
+++ b/drivers/target/target_core_sbc.c
@@ -573,7 +573,7 @@ sbc_compare_and_write(struct se_cmd *cmd)
 	int rc;
 	/*
 	 * Submit the READ first for COMPARE_AND_WRITE to perform the
-	 * comparision using SGLs at cmd->t_bidi_data_sg..
+	 * comparison using SGLs at cmd->t_bidi_data_sg..
 	 */
 	rc = down_interruptible(&dev->caw_sem);
 	if (rc != 0) {
diff --git a/drivers/target/target_core_spc.c b/drivers/target/target_core_spc.c
index 50290abc07bc..d45756de820a 100644
--- a/drivers/target/target_core_spc.c
+++ b/drivers/target/target_core_spc.c
@@ -294,7 +294,7 @@ spc_emulate_evpd_83(struct se_cmd *cmd, unsigned char *buf)
 
 		tpg = lun->lun_tpg;
 		/*
-		 * Relative target port identifer, see spc4r17
+		 * Relative target port identifier, see spc4r17
 		 * section 7.7.3.7
 		 *
 		 * Get the PROTOCOL IDENTIFIER as defined by spc4r17
@@ -305,7 +305,7 @@ spc_emulate_evpd_83(struct se_cmd *cmd, unsigned char *buf)
 		buf[off] = 0x80; /* Set PIV=1 */
 		/* Set ASSOCIATION == target port: 01b */
 		buf[off] |= 0x10;
-		/* DESIGNATOR TYPE == Relative target port identifer */
+		/* DESIGNATOR TYPE == Relative target port identifier */
 		buf[off++] |= 0x4;
 		off++; /* Skip over Reserved */
 		buf[off++] = 4; /* DESIGNATOR LENGTH */
@@ -388,7 +388,7 @@ spc_emulate_evpd_83(struct se_cmd *cmd, unsigned char *buf)
 		buf[off++] |= 0x8;
 		off += 2; /* Skip over Reserved and length */
 		/*
-		 * SCSI name string identifer containing, $FABRIC_MOD
+		 * SCSI name string identifier containing, $FABRIC_MOD
 		 * dependent information.  For LIO-Target and iSCSI
 		 * Target Port, this means "<iSCSI name>,t,0x<TPGT> in
 		 * UTF-8 encoding.
@@ -428,7 +428,7 @@ spc_emulate_evpd_83(struct se_cmd *cmd, unsigned char *buf)
 		buf[off++] |= 0x8;
 		off += 2; /* Skip over Reserved and length */
 		/*
-		 * SCSI name string identifer containing, $FABRIC_MOD
+		 * SCSI name string identifier containing, $FABRIC_MOD
 		 * dependent information.  For LIO-Target and iSCSI
 		 * Target Port, this means "<iSCSI name>" in
 		 * UTF-8 encoding.
diff --git a/drivers/target/target_core_transport.c b/drivers/target/target_core_transport.c
index 73d0d6133ac8..87ef8eede7d7 100644
--- a/drivers/target/target_core_transport.c
+++ b/drivers/target/target_core_transport.c
@@ -2146,7 +2146,7 @@ void __target_execute_cmd(struct se_cmd *cmd, bool do_checks)
 		/*
 		 * Check for an existing UNIT ATTENTION condition after
 		 * target_handle_task_attr() has done SAM task attr
-		 * checking, and possibly have already defered execution
+		 * checking, and possibly have already deferred execution
 		 * out to target_restart_delayed_cmds() context.
 		 */
 		ret = target_scsi3_ua_check(cmd);
@@ -3447,7 +3447,7 @@ static const struct sense_detail sense_detail_table[] = {
 		 * REGISTER AND MOVE service actionis attempted,
 		 * but there are insufficient device server resources to complete the
 		 * operation, then the command shall be terminated with CHECK CONDITION
-		 * status, with the sense key set to ILLEGAL REQUEST,and the additonal
+		 * status, with the sense key set to ILLEGAL REQUEST,and the additional
 		 * sense code set to INSUFFICIENT REGISTRATION RESOURCES.
 		 */
 		.key = ILLEGAL_REQUEST,
diff --git a/drivers/target/target_core_ua.h b/drivers/target/target_core_ua.h
index 76487c9be090..d295a5e65572 100644
--- a/drivers/target/target_core_ua.h
+++ b/drivers/target/target_core_ua.h
@@ -5,7 +5,7 @@
 #include <target/target_core_base.h>
 
 /*
- * From spc4r17, Table D.1: ASC and ASCQ Assignement
+ * From spc4r17, Table D.1: ASC and ASCQ Assignment
  */
 #define ASCQ_29H_POWER_ON_RESET_OR_BUS_DEVICE_RESET_OCCURED	0x00
 #define ASCQ_29H_POWER_ON_OCCURRED				0x01